
let default_config = {
    "Port": 3010, // HTTP端口
    "Subtitle": "<span>IP: 127.0.0.1</span>&nbsp;&nbsp;<span>Q群:xxxxx</span>", // 副标题
    "RequestMaxCount": 30, // 用户每分钟最多请求次数
    "imgMaxSize": 2048, // 上传图片大小限制(KB)
};
let Config_json = new JsonConfigFile(`./plugins/CustomGetMap_web/data/config.json`, JSON.stringify(default_config));
global.Config = JSON.parse(Config_json.read());
global.Password_json = new JsonConfigFile(`./plugins/CustomGetMap_web/data/password.json`);
//Password = JSON.parse(Password_json.read());


function registerCmd(){
    var cmd = mc.newCommand("uploadmap", "§e地图画上传设置", PermType.Any); //PermType.Any: 任何人,  PermType.GameMasters: 仅OP, PermType.Console: 仅控制台
    cmd.overload([]);
    cmd.setCallback((_cmd, _ori, out, res) => {
        //logger.debug(`命令执行的主体: ${_ori.type}`); 玩家：0 控制台 7
        let pl = _ori.player;
        if (pl == null){
            return out.error("此命令的执行者须为玩家");
        }
        mainForm(pl);
        return out.success("");
    });
    cmd.setup();
}

mc.listen("onServerStarted", ()=>{
    registerCmd();
    if (ll.hasExported("CustomGetMap", "add_player_upimg")) {
        global.CUSGETMAP = {
            add_player_upimg: ll.import('CustomGetMap', 'add_player_upimg'),
            del_player_upimg: ll.import('CustomGetMap', 'del_player_upimg'),
            get_player_upimg: ll.import('CustomGetMap', 'get_player_upimg'),
        };
    }else{
        logger.error(`CustomGetMap APi未导出，请检查是否安装CustomGetMap0.6.2以上版本`);
    }
    require('./app.js');
});

function mainForm(pl){
    if (pl == null){return;}
    let fm_mainForm = mc.newCustomForm()
    .setTitle("§c§l地图画上传设置")
    .addLabel(" §7上传密钥不要设置为个人敏感密码");
    if (Password_json.get(pl.realName) == null){
        fm_mainForm.addInput('§a上传密钥','字母数字或下划线', randomString(8));
    }else{
        fm_mainForm.addInput('§a上传密钥','字母数字或下划线', Password_json.get(pl.realName).password);
    }
    pl.sendForm(fm_mainForm, (pl, args)=>{
        if (args == null){return;}
        if (args[1] != Password_json.get(pl.realName)?.password){
            if (!/^\w+$/.test(args[1])){
                return menu_end(pl, '§c§l地图画上传设置', '§c密钥须为字母或数字或下划线', ()=>{mainForm(pl);});
            }
            Password_json.set(pl.realName, {
                realName: pl.realName,
                xuid: pl.xuid,
                uuid: pl.uuid,
                password: args[1]
            });
            //global.Password = JSON.parse(Password_json.read());
            return menu_end(pl, '§c§l地图画上传设置', `§a上传密钥已修改为: §e${args[1]}`, ()=>{mainForm(pl);});
        }
    });
    return;
}

// 结束菜单
function menu_end(pl, title, endmsg, lastForm, lastForm_run){
    //ver.23.7.12 lastForm作为回调函数，由需要pl参数改为无参
    var menu_end = mc.newSimpleForm();
    menu_end.setTitle(title);
    menu_end.setContent('\n\n'+endmsg+'\n\n\n\n');
    menu_end.addButton('§6§l退出菜单');
    if (lastForm != undefined){
        menu_end.addButton('§l返回上一页');
    }
    
    pl.sendForm(menu_end,function(pl,id){
        if (id == null){return;}
        if (id == 1){
			if (typeof lastForm == "function"){
				return lastForm();
			}else{
				return pl.sendForm(lastForm,lastForm_run);
			}
        }
    });
}

//随机字符串
function randomString(length, addSymbol){
    str='_1234567890ABCDEFGHIGKLMNOPQRSTUVWSYZabcdefghijklmnopqrstuvwsyz';
    symbol='-/:;()$&@.,?!_|~<>€£¥•[]{}#%^*+=';
    txt = '';
    if(addSymbol) str = str+symbol;
    if(isNaN(length)) return false;
    for(i = 0; i < length; i++){
        random = parseInt(Math.random()*(str.length+1),10);
        txt += str.split("")[random];
    }
    return txt;
}

