const uploadCustomMap = require("../multer/upload");

// 用户的逻辑控制器
class UserController {
    // 上传图片
    async upload(req, res) {
        try {
            if (global.CUSGETMAP == undefined) {
                return res.send({
                    success: false,
                    msg: "未导出CustomGetMap Api",
                });
            }
            const uploadRes = await uploadCustomMap(req, res);
            if (uploadRes.success) {
                CUSGETMAP.add_player_upimg(
                    req.body.username,
                    req.body.imgFileName
                );
            }
            res.send({
                success: uploadRes.success,
                msg: uploadRes.msg,
                imgFileName: uploadRes.imgFileName,
                //meta: { code: 200, msg: "请求成功" },
                //data: { id: uploadRes.id, img_url: uploadRes.img_url }
            });
        } catch (error) {
            console.log(error);
        }
    }

    async getPlayerInfo(req, res) {
        try {
            if (global.CUSGETMAP == undefined) {
                return res.send({
                    success: false,
                    msg: "未导出CustomGetMap Api",
                });
            }
            let data = CUSGETMAP.get_player_upimg(req.cookies.username);
            if (data == null) {
                return res.send({
                    success: false,
                    msg: `<${req.cookies.username}> 未上传过图片`,
                });
            }
            res.send({
                success: true,
                data: data,
            });
        } catch (error) {
            res.send(error);
        }
    }

    async delete(req, res) {
        try {
            if (global.CUSGETMAP == undefined) {
                return res.send({
                    success: false,
                    msg: "未导出CustomGetMap Api",
                });
            }
            let delres = CUSGETMAP.del_player_upimg(
                req.cookies.username,
                req.query.imgFileName,
                false
            );
            if (delres.success) {
                log(
                    `${req.cookies.username} 在Web端删除了 ${req.query.imgFileName}`
                );
            }
            res.send({
                success: delres.success,
                data: {
                    imgFileName: req.query.imgFileName,
                },
                msg: delres.output,
            });
        } catch (error) {
            res.send(error);
        }
    }
}

module.exports = new UserController();
